<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>behaviourlayer/behave.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">behaviourlayer/behave.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2001 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment">  </span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment">  </span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment">  </span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_BL_BEHAVE__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_BL_BEHAVE__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;stdarg.h&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/strhash_8h.html">csutil/strhash.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;physicallayer/datatype.h&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">struct </span><a class="code" href="structiCelBlLayer.html" title="This is the Behaviour Layer itself.">iCelBlLayer</a>;
<a name="l00031"></a>00031 <span class="keyword">struct </span><a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>;
<a name="l00032"></a>00032 
<a name="l00038"></a><a class="code" href="structiCelParameterBlock.html">00038</a> <span class="keyword">struct </span><a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040   SCF_INTERFACE (<a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>, 0, 0, 1);
<a name="l00041"></a>00041 
<a name="l00045"></a>00045   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="structiCelParameterBlock.html#a3a66b42c65946965dd3f12b66e7da4dc" title="Get number of parameters.">GetParameterCount</a> () <span class="keyword">const</span> = 0;
<a name="l00046"></a>00046 
<a name="l00051"></a>00051   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> <a class="code" href="structiCelParameterBlock.html#a48f49c5f5f6ee88f2aa65065e296521c" title="Get parameter with index.">GetParameterDef</a> (<span class="keywordtype">size_t</span> idx, celDataType&amp; t) <span class="keyword">const</span> = 0;
<a name="l00052"></a>00052 
<a name="l00056"></a>00056   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>* <a class="code" href="structiCelParameterBlock.html#a320b5d78ceb8de02a8938f603a2e4084" title="Get parameter given an id.">GetParameter</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> <span class="keywordtype">id</span>) <span class="keyword">const</span> = 0;
<a name="l00057"></a>00057 
<a name="l00061"></a>00061   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>* <a class="code" href="structiCelParameterBlock.html#ab4e6774c7ac75f7936e19d6c145c84f8" title="Get parameter given an index.">GetParameterByIndex</a> (<span class="keywordtype">size_t</span> idx) <span class="keyword">const</span> = 0;
<a name="l00062"></a>00062 };
<a name="l00063"></a>00063 
<a name="l00067"></a><a class="code" href="structiCelBehaviour.html">00067</a> <span class="keyword">struct </span><a class="code" href="structiCelBehaviour.html" title="This is an entity in the CEL layer at the BL (behaviour layer) side.">iCelBehaviour</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00068"></a>00068 {
<a name="l00069"></a>00069   SCF_INTERFACE (<a class="code" href="structiCelBehaviour.html" title="This is an entity in the CEL layer at the BL (behaviour layer) side.">iCelBehaviour</a>, 0, 0, 2);
<a name="l00070"></a>00070 
<a name="l00075"></a>00075   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiCelBehaviour.html#aa2ba63c6f112f59ae8139f60457758cd" title="Get the name of this behaviour (was used in the call to iCelBlLayer::CreateBehaviour()).">GetName</a> () <span class="keyword">const</span> = 0;
<a name="l00076"></a>00076 
<a name="l00080"></a>00080   <span class="keyword">virtual</span> <a class="code" href="structiCelBlLayer.html" title="This is the Behaviour Layer itself.">iCelBlLayer</a>* <a class="code" href="structiCelBehaviour.html#a1eaf0d56e221b02cb5883ddcc5ef2009" title="Get the behaviour layer that created this behaviour.">GetBehaviourLayer</a> () <span class="keyword">const</span> = 0;
<a name="l00081"></a>00081 
<a name="l00087"></a>00087   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelBehaviour.html#ad52d49a02902d72f2cb3ff8934b21758" title="Send a message to this entity.">SendMessage</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* msg_id,
<a name="l00088"></a>00088         <a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* pc,
<a name="l00089"></a>00089         <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>&amp; ret, <a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>* params, ...) = 0;
<a name="l00090"></a>00090 
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelBehaviour.html#ac41d70cc01d673ca39a2afc883d5d793" title="Send a message to this entity.">SendMessageV</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* msg_id,
<a name="l00096"></a>00096         <a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* pc,
<a name="l00097"></a>00097         <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>&amp; ret, <a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>* params, va_list arg) = 0;
<a name="l00098"></a>00098 
<a name="l00107"></a>00107   <span class="keyword">virtual</span> <span class="keywordtype">void</span>* <a class="code" href="structiCelBehaviour.html#a159d449ba2285d587844e4f85d58b912" title="This is a function intended for implementations of behaviour layers.">GetInternalObject</a> () = 0;
<a name="l00108"></a>00108 };
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 <span class="preprocessor">#endif // __CEL_BL_BEHAVE__</span>
<a name="l00111"></a>00111 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
